// Задача о 8 ферзях из книги Н. Вирта.
// Алгоритмы и структуры данных: Пер. с англ. –
// М.: Мир, 1989. – 360с

#include <iostream>
using namespace std;

// массив для отметки занятости горизонталей
bool a[8]; 
// массив для отметки занятости побочных диагоналей
bool b[15]; 
// массив для отметки занятости прямых диагоналей
bool c[15]; 
// массив для фиксации строк 
int  x[8];

void Try(int i, bool& q) {
  int j = -1;
  do  {
    j += 1;
    q = false;
    if(a[j] && b[i+j] && c[i-j+7]) {
      x[i] = j;
      // Ферзь бьет горизонталь и диагонали
      a[j] = b[i+j] = c[i-j+7] = false;
      if(i < 7) {
        Try(i+1, q);
        if(!q) {
          a[j] = b[i+j] = c[i-j+7] = true;
        }
      } else {
        q = true;
      }
    }
  } while(!(q || (j == 7)));
}

int main()
{
  int i;
  bool q;

  for(i = 0; i < 8; i++) 
      a[i] = true;
  for(i = 0; i < 15; i++) 
      b[i] = c[i] = true;
  
  Try(0, q);
  
  for(i = 0; i < 8; i++) 
     cout << x[i]+1 << "   ";
  cout << endl;
  
  return 0;
}
